package com.knauf.ejb.kuchen;

import java.awt.GridBagLayout;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JDialog;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import java.awt.event.ActionEvent;

import javax.swing.JTextField;
import javax.swing.JButton;

/**
 * @author Wolfgang Knauf
 *
 */
public class DialogKuchen extends JDialog
{

  private JPanel jContentPane = null;

  private JLabel jLabelName = null;

  private JTextField jTextFieldName = null;

  private JButton jButtonOK = null;

  private JButton jButtonCancel = null;

  /**Wurde der Dialog mit einem Klick auf "OK" beendet ? */
  private boolean bolOKClicked = false;

  /**Der Kuchen-Name, wird beim Klick auf OK aus dem Textfeld geholt. */
  private String strName = "";

  /**
   * This is the default constructor
   */
  public DialogKuchen()
  {
    super();
    initialize();
  }

  /**
   * This is the default constructor
   * @param frameParent Parent-Frame.
   */
  public DialogKuchen(JFrame frameParent)
  {
    super(frameParent);
    initialize();
  }

  /**
   * This method initializes this
   * 
   * @return void
   */
  private void initialize()
  {
    this.setSize(300, 109);
    this.setModal(true);
    this.setTitle("Kuchen bearbeiten");
    this.setContentPane(getJContentPane());
  }

  /**
   * This method initializes jContentPane
   * 
   * @return javax.swing.JPanel
   */
  private JPanel getJContentPane()
  {
    if (jContentPane == null)
    {
      GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
      gridBagConstraints4.gridx = 1;
      gridBagConstraints4.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints4.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints4.gridy = 2;
      GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
      gridBagConstraints2.gridx = 1;
      gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints2.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints2.gridy = 1;
      GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
      gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints1.gridy = 2;
      gridBagConstraints1.weightx = 1.0;
      gridBagConstraints1.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints1.gridx = 0;
      GridBagConstraints gridBagConstraints = new GridBagConstraints();
      gridBagConstraints.gridx = 0;
      gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
      gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints.gridy = 1;
      jLabelName = new JLabel();
      jLabelName.setText("Kuchen-Name");
      jContentPane = new JPanel();
      jContentPane.setLayout(new GridBagLayout());
      jContentPane.add(jLabelName, gridBagConstraints);
      jContentPane.add(getJTextFieldName(), gridBagConstraints1);
      jContentPane.add(getJButtonOK(), gridBagConstraints2);
      jContentPane.add(getJButtonCancel(), gridBagConstraints4);
    }
    return jContentPane;
  }

  /**
   * This method initializes jTextFieldName	
   * 	
   * @return javax.swing.JTextField	
   */
  private JTextField getJTextFieldName()
  {
    if (jTextFieldName == null)
    {
      jTextFieldName = new JTextField();
    }
    return jTextFieldName;
  }

  /**
   * This method initializes jButtonOK	
   * 	
   * @return javax.swing.JButton	
   */
  private JButton getJButtonOK()
  {
    if (jButtonOK == null)
    {
      jButtonOK = new JButton();
      jButtonOK.setText("OK");
      jButtonOK.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          jButtonOK_actionPerformed(e);
        }
      });
    }
    return jButtonOK;
  }

  /**
   * This method initializes jButtonCancel	
   * 	
   * @return javax.swing.JButton	
   */
  private JButton getJButtonCancel()
  {
    if (jButtonCancel == null)
    {
      jButtonCancel = new JButton();
      jButtonCancel.setText("Abbrechen");
      jButtonCancel.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          jButtonCancel_actionPerformed(e);
        }
      });
    }
    return jButtonCancel;
  }

  /**Klick auf "OK".
   * @param e ActionEvent
   */
  void jButtonOK_actionPerformed(ActionEvent e)
  {
    //Speichern, ob auf OK geklickt wurde.
    this.bolOKClicked = true;

    //Den Kuchen-Namen speichern.
    this.strName = this.jTextFieldName.getText();

    this.dispose();
  }

  /**Klick auf Abbrechen: Dialog schlieen.
   * @param e ActionEvent.
   */
  void jButtonCancel_actionPerformed(ActionEvent e)
  {
    this.dispose();

  }

  /**Wurde der Dialog mit einem Klick auf OK beendet ?
   * @return TRUE, wenn OK geklickt wurde. FALSE bei Klick auf Abbrechen o..
   */
  public boolean isOKClicked()
  {
    return this.bolOKClicked;
  }

  /**Setzen des Namens.
   * Wird in Instanz-Variable + Textfeld geschrieben.
   * @param str_Name der Name.
   */
  public void setName(String str_Name)
  {
    this.strName = str_Name;
    this.jTextFieldName.setText(str_Name);
  }

  /**Abrufen des Namens. Wird beim OK-Klick in Instanzvariable geschrieben, diese wird
   * hier zurckgeliefert.
   * @return Der Name.
   */
  public String getName()
  {
    return this.strName;
  }

} //  @jve:decl-index=0:visual-constraint="10,10"
