package com.knauf.ejb.kuchen;

import java.awt.GridBagLayout;

import javax.ejb.FinderException;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import java.awt.GridBagConstraints;
import java.awt.event.ActionEvent;
import java.rmi.RemoteException;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.JList;

/**
 * @author Wolfgang Knauf
 *
 */
public class FrameKuchen extends JFrame
{

  private JPanel jContentPane = null;

  private JButton jButtonNeu = null;

  private JScrollPane jScrollPaneKuchen = null;

  private JList jListKuchen = null;

  private JButton jButtonBearbeiten = null;

  private JButton jButtonLoeschen = null;

  /**Kuchen-Home-Interface, wird im Konstruktor erzeugt. */
  private KuchenSingleHome kuchenHome = null;

  /**Vector mit den aktuell Primary keys der Kuchen in der Listbox */
  private Vector vectorPrimaryKey = null;

  /**
   * This method initializes jButton	
   * 	
   * @return javax.swing.JButton	
   */
  private JButton getJButtonNeu()
  {
    if (jButtonNeu == null)
    {
      jButtonNeu = new JButton();
      jButtonNeu.setText("Neu");
      jButtonNeu.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          jButtonNeu_actionPerformed(e);
        }
      });
    }
    return jButtonNeu;
  }

  /**
   * This method initializes jScrollPaneKuchen	
   * 	
   * @return javax.swing.JScrollPane	
   */
  private JScrollPane getJScrollPaneKuchen()
  {
    if (jScrollPaneKuchen == null)
    {
      jScrollPaneKuchen = new JScrollPane();
      jScrollPaneKuchen.setViewportView(getJListKuchen());
    }
    return jScrollPaneKuchen;
  }

  /**
   * This method initializes jListKuchen	
   * 	
   * @return javax.swing.JList	
   */
  private JList getJListKuchen()
  {
    if (jListKuchen == null)
    {
      jListKuchen = new JList();
    }
    return jListKuchen;
  }

  /**
   * This method initializes jButtonBearbeiten	
   * 	
   * @return javax.swing.JButton	
   */
  private JButton getJButtonBearbeiten()
  {
    if (jButtonBearbeiten == null)
    {
      jButtonBearbeiten = new JButton();
      jButtonBearbeiten.setText("Bearbeiten");
      jButtonBearbeiten.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          jButtonBearbeiten_actionPerformed(e);
        }
      });
    }
    return jButtonBearbeiten;
  }

  /**
   * This method initializes jButtonLoeschen	
   * 	
   * @return javax.swing.JButton	
   */
  private JButton getJButtonLoeschen()
  {
    if (jButtonLoeschen == null)
    {
      jButtonLoeschen = new JButton();
      jButtonLoeschen.setText("Lschen");
      jButtonLoeschen.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
          jButtonLoeschen_actionPerformed(e);
        }
      });
    }
    return jButtonLoeschen;
  }

  /**
   * This is the default constructor
   */
  public FrameKuchen()
  {
    super();
    initialize();

    try
    {
      //Alle Kuchen laden:
      //Kuchen-Home-Interface holen:
      InitialContext initialContext = new InitialContext();
      Object homeref = initialContext.lookup("java:comp/env/ejb/KuchenSingle");

      this.kuchenHome = (KuchenSingleHome) PortableRemoteObject.narrow(homeref, KuchenSingleHome.class);

      //Liste fllen
      this.fillKuchen();

    }
    catch (Exception e)
    {
      e.printStackTrace();
    }

  }

  /**
   * This method initializes this
   * 
   * @return void
   */
  private void initialize()
  {
    this.setSize(300, 200);
    this.setContentPane(getJContentPane());
    this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    this.setTitle("JFrame");
  }

  /**
   * This method initializes jContentPane
   * 
   * @return javax.swing.JPanel
   */
  private JPanel getJContentPane()
  {
    if (jContentPane == null)
    {
      GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
      gridBagConstraints3.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints3.gridy = 0;
      gridBagConstraints3.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints3.gridx = 1;
      GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
      gridBagConstraints2.gridx = 1;
      gridBagConstraints2.anchor = java.awt.GridBagConstraints.NORTH;
      gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints2.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints2.gridy = 2;
      GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
      gridBagConstraints1.gridx = 1;
      gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints1.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints1.gridy = 1;
      GridBagConstraints gridBagConstraints = new GridBagConstraints();
      gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
      gridBagConstraints.gridy = 0;
      gridBagConstraints.weightx = 1.0;
      gridBagConstraints.weighty = 1.0;
      gridBagConstraints.gridheight = 3;
      gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
      gridBagConstraints.gridx = 0;
      jContentPane = new JPanel();
      jContentPane.setLayout(new GridBagLayout());
      jContentPane.add(getJScrollPaneKuchen(), gridBagConstraints);
      jContentPane.add(getJButtonNeu(), gridBagConstraints3);
      jContentPane.add(getJButtonBearbeiten(), gridBagConstraints1);
      jContentPane.add(getJButtonLoeschen(), gridBagConstraints2);
    }
    return jContentPane;
  }

  /**Befllen der Kuchen-Liste.
   * @exception FinderException Fehler beim Suchen der listbox-Elemente
   * @exception RemoteException Fehler beim Suchen der listbox-Elemente
   */
  private void fillKuchen() throws FinderException, RemoteException
  {
    //Liste leeren:
    this.jListKuchen.removeAll();

    //Alle Kuchen holen:
    Collection collKuchen = kuchenHome.findAll();

    //Eine Liste der Namen erzeugen (toString eines Kuchen liefert den vom Container erzeugten Primary Key zurck !).
    Vector vectorNamen = new Vector();
    //Die Primary Keys ebenfalls in einer Instanzvariable speichern.
    this.vectorPrimaryKey = new Vector();
    Iterator iteratorKuchen = collKuchen.iterator();
    while (iteratorKuchen.hasNext() == true)
    {
      KuchenSingle kuchenAktuell = (KuchenSingle) iteratorKuchen.next();
      vectorNamen.add(kuchenAktuell.getName());
      this.vectorPrimaryKey.add(kuchenAktuell.getPrimaryKey());
    }

    this.jListKuchen.setListData(vectorNamen.toArray());

  }

  /**Klick auf "Neu": Anlegen eines neuen Kuchens.
   * @param e ActionEvent
   */
  void jButtonNeu_actionPerformed(ActionEvent e)
  {
    try
    {
      //Dialog anzeigen:
      DialogKuchen dialogKuchen = new DialogKuchen(this);

      dialogKuchen.show();

      //Wurde im Dialog auf OK geklickt ?
      if (dialogKuchen.isOKClicked() == false)
        return;

      //Neuen Kuchen erzeugen:
      //KuchenSingle kuchenNeu = this.kuchenHome.createByName(dialogKuchen.getName() );
      KuchenSingle kuchenNeu = this.kuchenHome.create();
      kuchenNeu.setName(dialogKuchen.getName());

      //Liste neu fllen:
      this.fillKuchen();
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }

  /**Klick auf Bearbeiten: Den gewhlten Kuchen bearbeiten
   * @param e ActionEVent
   */
  void jButtonBearbeiten_actionPerformed(ActionEvent e)
  {
    try
    {
      //Ist ein Kuchen gewhlt ?
      if (this.jListKuchen.getSelectedIndex() == -1)
      {
        JOptionPane.showMessageDialog(this, "Bitte whlen Sie einen Kuchen aus");
        return;
      }

      //Den primary Key zum gewhlten Objekt holen (hier ist der Typ ein Integer !)
      Object objPrimaryKey = this.vectorPrimaryKey.get(this.jListKuchen.getSelectedIndex());
      Integer intPrimaryKey = (Integer) objPrimaryKey;

      //Den Kuchen dazu finden.
      KuchenSingle kuchenEdit = this.kuchenHome.findByPrimaryKey(intPrimaryKey);

      DialogKuchen dialogKuchen = new DialogKuchen(this);

      //Den Namen in den Dialog setzen:
      dialogKuchen.setName(kuchenEdit.getName());

      //Auf OK-Klick warten:
      dialogKuchen.show();
      if (dialogKuchen.isOKClicked() == false)
        return;

      //Speichern:
      kuchenEdit.setName(dialogKuchen.getName());

      //Fertig, Liste neu fllen.
      this.fillKuchen();
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }

  /**Klick auf "Lschen": Lschen des gewhlten Kuchens ohne weitere Kommentare.
   * @param e ActionEvent.
   */
  void jButtonLoeschen_actionPerformed(ActionEvent e)
  {
    try
    {
      //Ist ein Kuchen gewhlt ?
      if (this.jListKuchen.getSelectedIndex() == -1)
      {
        JOptionPane.showMessageDialog(this, "Bitte whlen Sie einen Kuchen aus");
        return;
      }

      //Den primary Key zum gewhlten Objekt holen (hier ist der Typ ein Integer !)
      Object objPrimaryKey = this.vectorPrimaryKey.get(this.jListKuchen.getSelectedIndex());
      Integer intPrimaryKey = (Integer) objPrimaryKey;
      
      //Den Kuchen dazu finden.
      KuchenSingle kuchenEdit = this.kuchenHome.findByPrimaryKey(intPrimaryKey);

      //Lschen. (hier wre eine "Wollen Sie wirklich lschen"-Abfrage vorher ganz schn.
      kuchenEdit.remove();

      //Fertig, Liste neu fllen.
      this.fillKuchen();
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }

}
